import assert from "node:assert"
import dotenv from "dotenv"

dotenv.config()

export const ACTUAL_BUDGET_ID = getOrThrow("ACTUAL_BUDGET_ID")
export const ACTUAL_SYNC_ID = getOrThrow("ACTUAL_SYNC_ID")
export const ACTUAL_SERVER_URL = getOrThrow("ACTUAL_SERVER_URL")
export const ACTUAL_PASSWORD = getOrThrow("ACTUAL_PASSWORD")
export const ACTUAL_DATA_DIR = "data/cache"
export const ACTUAL_ACCOUNT_IDS = getArrayOrThrow("ACTUAL_ACCOUNT_IDS")

export const SPAREBANK1_OAUTH_CLIENT_ID = getOrThrow(
  "SPAREBANK1_OAUTH_CLIENT_ID",
)
export const SPAREBANK1_OAUTH_CLIENT_SECRET = getOrThrow(
  "SPAREBANK1_OAUTH_CLIENT_SECRET",
)
export const SPAREBANK1_OAUTH_REDIRECT_URI = getOrThrow(
  "SPAREBANK1_OAUTH_REDIRECT_URI",
)
export const SPAREBANK1_OAUTH_STATE = getOrThrow("SPAREBANK1_OAUTH_STATE")
export const BANK_ACCOUNT_IDS = getArrayOrThrow("BANK_ACCOUNT_IDS")

function getOrThrow(key: string): string {
  const value = process.env[key]
  assert(value, `Missing environment variable: ${key}`)
  return value
}

function getArrayOrThrow(key: string): ReadonlyArray<string> {
  return getOrThrow(key).split(",")
}
